org.apache.hc.client5.http.impl.classic

## Class HttpClientBuilder

- java.lang.Object
- - org.apache.hc.client5.http.impl.classic.HttpClientBuilder

    public class HttpClientBuilder
    extends Object

Builder for `CloseableHttpClient` instances.

When a particular component is not explicitly set this class will use its default implementation. System properties will be taken into account when configuring the default implementations when `useSystemProperties()` method is called prior to calling `build()`.

- http.proxyHost
- http.proxyPort
- https.proxyHost
- https.proxyPort
- http.nonProxyHosts
- https.proxyUser
- http.proxyUser
- https.proxyPassword
- http.proxyPassword
- http.keepAlive
- http.agent

Please note that some settings used by this class can be mutually exclusive and may not apply when building `CloseableHttpClient` instances.

Since:
  4.3

### Constructor Summary

Constructors
`protected` `HttpClientBuilder()`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected void` `addCloseable(Closeable closeable)` Adds to the list of `Closeable` resources to be managed by the client.
`HttpClientBuilder` `addExecInterceptorAfter(String existing, String name, ExecChainHandler interceptor)` Adds this execution interceptor after interceptor with the given name.
`HttpClientBuilder` `addExecInterceptorBefore(String existing, String name, ExecChainHandler interceptor)` Adds this execution interceptor before an existing interceptor.
`HttpClientBuilder` `addExecInterceptorFirst(String name, ExecChainHandler interceptor)` Add an interceptor to the head of the processing list.
`HttpClientBuilder` `addExecInterceptorLast(String name, ExecChainHandler interceptor)` Add an interceptor to the tail of the processing list.
`HttpClientBuilder` `addRequestInterceptorFirst(HttpRequestInterceptor interceptor)` Adds this protocol interceptor to the head of the protocol processing list.
`HttpClientBuilder` `addRequestInterceptorLast(HttpRequestInterceptor interceptor)` Adds this protocol interceptor to the tail of the protocol processing list.
`HttpClientBuilder` `addResponseInterceptorFirst(HttpResponseInterceptor interceptor)` Adds this protocol interceptor to the head of the protocol processing list.
`HttpClientBuilder` `addResponseInterceptorLast(HttpResponseInterceptor interceptor)` Adds this protocol interceptor to the tail of the protocol processing list.
`CloseableHttpClient` `build()`
`static HttpClientBuilder` `create()`
`protected void` `customizeExecChain(NamedElementChain<ExecChainHandler> execChainDefinition)` Request exec chain customization and extension.
`HttpClientBuilder` `disableAuthCaching()` Disables authentication scheme caching.
`HttpClientBuilder` `disableAutomaticRetries()` Disables automatic request recovery and re-execution.
`HttpClientBuilder` `disableConnectionState()` Disables connection state tracking.
`HttpClientBuilder` `disableContentCompression()` Disables automatic content decompression.
`HttpClientBuilder` `disableCookieManagement()` Disables state (cookie) management.
`HttpClientBuilder` `disableDefaultUserAgent()` Disables the default user agent set by this builder if none has been provided by the user.
`HttpClientBuilder` `disableRedirectHandling()` Disables automatic redirect handling.
`HttpClientBuilder` `evictExpiredConnections()` Makes this instance of HttpClient proactively evict expired connections from the connection pool using a background thread.
`HttpClientBuilder` `evictIdleConnections(TimeValue maxIdleTime)` Makes this instance of HttpClient proactively evict idle connections from the connection pool using a background thread.
`HttpClientBuilder` `replaceExecInterceptor(String existing, ExecChainHandler interceptor)` Replace an existing interceptor with the given name with new interceptor.
`HttpClientBuilder` `setBackoffManager(BackoffManager backoffManager)` Assigns `BackoffManager` instance.
`HttpClientBuilder` `setConnectionBackoffStrategy(ConnectionBackoffStrategy connectionBackoffStrategy)` Assigns `ConnectionBackoffStrategy` instance.
`HttpClientBuilder` `setConnectionManager(HttpClientConnectionManager connManager)` Assigns `HttpClientConnectionManager` instance.
`HttpClientBuilder` `setConnectionManagerShared(boolean shared)` Defines the connection manager is to be shared by multiple client instances.
`HttpClientBuilder` `setConnectionReuseStrategy(ConnectionReuseStrategy reuseStrategy)` Assigns `ConnectionReuseStrategy` instance.
`HttpClientBuilder` `setContentDecoderRegistry(LinkedHashMap<String,InputStreamFactory> contentDecoderMap)` Assigns a map of `InputStreamFactory`s to be used for automatic content decompression.
`HttpClientBuilder` `setDefaultAuthSchemeRegistry(Lookup<AuthSchemeFactory> authSchemeRegistry)` Assigns default `AuthScheme` registry which will be used for request execution if not explicitly set in the client execution context.
`HttpClientBuilder` `setDefaultCookieSpecRegistry(Lookup<CookieSpecFactory> cookieSpecRegistry)` Assigns default `CookieSpec` registry which will be used for request execution if not explicitly set in the client execution context.
`HttpClientBuilder` `setDefaultCookieStore(CookieStore cookieStore)` Assigns default `CookieStore` instance which will be used for request execution if not explicitly set in the client execution context.
`HttpClientBuilder` `setDefaultCredentialsProvider(CredentialsProvider credentialsProvider)` Assigns default `CredentialsProvider` instance which will be used for request execution if not explicitly set in the client execution context.
`HttpClientBuilder` `setDefaultHeaders(Collection<? extends Header> defaultHeaders)` Assigns default request header values.
`HttpClientBuilder` `setDefaultRequestConfig(RequestConfig config)` Assigns default `RequestConfig` instance which will be used for request execution if not explicitly set in the client execution context.
`HttpClientBuilder` `setKeepAliveStrategy(ConnectionKeepAliveStrategy keepAliveStrategy)` Assigns `ConnectionKeepAliveStrategy` instance.
`HttpClientBuilder` `setProxy(HttpHost proxy)` Assigns default proxy value.
`HttpClientBuilder` `setProxyAuthenticationStrategy(AuthenticationStrategy proxyAuthStrategy)` Assigns `AuthenticationStrategy` instance for proxy authentication.
`HttpClientBuilder` `setProxySelector(ProxySelector proxySelector)` Sets the `ProxySelector` that will be used to select the proxies to be used for establishing HTTP connections.
`HttpClientBuilder` `setRedirectStrategy(RedirectStrategy redirectStrategy)` Assigns `RedirectStrategy` instance.
`HttpClientBuilder` `setRequestExecutor(HttpRequestExecutor requestExec)` Assigns `HttpRequestExecutor` instance.
`HttpClientBuilder` `setRetryStrategy(HttpRequestRetryStrategy retryStrategy)` Assigns `HttpRequestRetryStrategy` instance.
`HttpClientBuilder` `setRoutePlanner(HttpRoutePlanner routePlanner)` Assigns `HttpRoutePlanner` instance.
`HttpClientBuilder` `setSchemePortResolver(SchemePortResolver schemePortResolver)` Assigns `SchemePortResolver` instance.
`HttpClientBuilder` `setTargetAuthenticationStrategy(AuthenticationStrategy targetAuthStrategy)` Assigns `AuthenticationStrategy` instance for target host authentication.
`HttpClientBuilder` `setUserAgent(String userAgent)` Assigns `User-Agent` value.
`HttpClientBuilder` `setUserTokenHandler(UserTokenHandler userTokenHandler)` Assigns `UserTokenHandler` instance.
`HttpClientBuilder` `useSystemProperties()` Use system properties when creating and configuring default implementations.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### HttpClientBuilder

    protected HttpClientBuilder()

### Method Detail

#### create

    public static HttpClientBuilder create()

#### setRequestExecutor

    public final HttpClientBuilder setRequestExecutor(HttpRequestExecutor requestExec)

Assigns `HttpRequestExecutor` instance.

#### setConnectionManager

    public final HttpClientBuilder setConnectionManager(HttpClientConnectionManager connManager)

Assigns `HttpClientConnectionManager` instance.

#### setConnectionManagerShared

    public final HttpClientBuilder setConnectionManagerShared(boolean shared)

Defines the connection manager is to be shared by multiple client instances.

If the connection manager is shared its life-cycle is expected to be managed by the caller and it will not be shut down if the client is closed.

Parameters:
  `shared` - defines whether or not the connection manager can be shared by multiple clients.
Since:
  4.4

#### setConnectionReuseStrategy

    public final HttpClientBuilder setConnectionReuseStrategy(ConnectionReuseStrategy reuseStrategy)

Assigns `ConnectionReuseStrategy` instance.

#### setKeepAliveStrategy

    public final HttpClientBuilder setKeepAliveStrategy(ConnectionKeepAliveStrategy keepAliveStrategy)

Assigns `ConnectionKeepAliveStrategy` instance.

#### setTargetAuthenticationStrategy

    public final HttpClientBuilder setTargetAuthenticationStrategy(AuthenticationStrategy targetAuthStrategy)

Assigns `AuthenticationStrategy` instance for target host authentication.

#### setProxyAuthenticationStrategy

    public final HttpClientBuilder setProxyAuthenticationStrategy(AuthenticationStrategy proxyAuthStrategy)

Assigns `AuthenticationStrategy` instance for proxy authentication.

#### setUserTokenHandler

    public final HttpClientBuilder setUserTokenHandler(UserTokenHandler userTokenHandler)

Assigns `UserTokenHandler` instance.

Please note this value can be overridden by the `disableConnectionState()` method.

#### disableConnectionState

    public final HttpClientBuilder disableConnectionState()

Disables connection state tracking.

#### setSchemePortResolver

    public final HttpClientBuilder setSchemePortResolver(SchemePortResolver schemePortResolver)

Assigns `SchemePortResolver` instance.

#### setUserAgent

    public final HttpClientBuilder setUserAgent(String userAgent)

Assigns `User-Agent` value.

#### setDefaultHeaders

    public final HttpClientBuilder setDefaultHeaders(Collection<? extends Header> defaultHeaders)

Assigns default request header values.

#### addResponseInterceptorFirst

    public final HttpClientBuilder addResponseInterceptorFirst(HttpResponseInterceptor interceptor)

Adds this protocol interceptor to the head of the protocol processing list.

#### addResponseInterceptorLast

    public final HttpClientBuilder addResponseInterceptorLast(HttpResponseInterceptor interceptor)

Adds this protocol interceptor to the tail of the protocol processing list.

#### addRequestInterceptorFirst

    public final HttpClientBuilder addRequestInterceptorFirst(HttpRequestInterceptor interceptor)

Adds this protocol interceptor to the head of the protocol processing list.

#### addRequestInterceptorLast

    public final HttpClientBuilder addRequestInterceptorLast(HttpRequestInterceptor interceptor)

Adds this protocol interceptor to the tail of the protocol processing list.

#### addExecInterceptorBefore

    public final HttpClientBuilder addExecInterceptorBefore(String existing,
                                                            String name,
                                                            ExecChainHandler interceptor)

Adds this execution interceptor before an existing interceptor.

#### addExecInterceptorAfter

    public final HttpClientBuilder addExecInterceptorAfter(String existing,
                                                           String name,
                                                           ExecChainHandler interceptor)

Adds this execution interceptor after interceptor with the given name.

#### replaceExecInterceptor

    public final HttpClientBuilder replaceExecInterceptor(String existing,
                                                          ExecChainHandler interceptor)

Replace an existing interceptor with the given name with new interceptor.

#### addExecInterceptorFirst

    public final HttpClientBuilder addExecInterceptorFirst(String name,
                                                           ExecChainHandler interceptor)

Add an interceptor to the head of the processing list.

#### addExecInterceptorLast

    public final HttpClientBuilder addExecInterceptorLast(String name,
                                                          ExecChainHandler interceptor)

Add an interceptor to the tail of the processing list.

#### disableCookieManagement

    public final HttpClientBuilder disableCookieManagement()

Disables state (cookie) management.

#### disableContentCompression

    public final HttpClientBuilder disableContentCompression()

Disables automatic content decompression.

#### disableAuthCaching

    public final HttpClientBuilder disableAuthCaching()

Disables authentication scheme caching.

#### setRetryStrategy

    public final HttpClientBuilder setRetryStrategy(HttpRequestRetryStrategy retryStrategy)

Assigns `HttpRequestRetryStrategy` instance.

Please note this value can be overridden by the `disableAutomaticRetries()` method.

#### disableAutomaticRetries

    public final HttpClientBuilder disableAutomaticRetries()

Disables automatic request recovery and re-execution.

#### setProxy

    public final HttpClientBuilder setProxy(HttpHost proxy)

Assigns default proxy value.

Please note this value can be overridden by the `setRoutePlanner( org.apache.hc.client5.http.routing.HttpRoutePlanner)` method.

#### setRoutePlanner

    public final HttpClientBuilder setRoutePlanner(HttpRoutePlanner routePlanner)

Assigns `HttpRoutePlanner` instance.

#### setRedirectStrategy

    public final HttpClientBuilder setRedirectStrategy(RedirectStrategy redirectStrategy)

Assigns `RedirectStrategy` instance.

Please note this value can be overridden by the `disableRedirectHandling()` method.

`

#### disableRedirectHandling

    public final HttpClientBuilder disableRedirectHandling()

Disables automatic redirect handling.

#### setConnectionBackoffStrategy

    public final HttpClientBuilder setConnectionBackoffStrategy(ConnectionBackoffStrategy connectionBackoffStrategy)

Assigns `ConnectionBackoffStrategy` instance.

#### setBackoffManager

    public final HttpClientBuilder setBackoffManager(BackoffManager backoffManager)

Assigns `BackoffManager` instance.

#### setDefaultCookieStore

    public final HttpClientBuilder setDefaultCookieStore(CookieStore cookieStore)

Assigns default `CookieStore` instance which will be used for request execution if not explicitly set in the client execution context.

#### setDefaultCredentialsProvider

    public final HttpClientBuilder setDefaultCredentialsProvider(CredentialsProvider credentialsProvider)

Assigns default `CredentialsProvider` instance which will be used for request execution if not explicitly set in the client execution context.

#### setDefaultAuthSchemeRegistry

    public final HttpClientBuilder setDefaultAuthSchemeRegistry(Lookup<AuthSchemeFactory> authSchemeRegistry)

Assigns default `AuthScheme` registry which will be used for request execution if not explicitly set in the client execution context.

#### setDefaultCookieSpecRegistry

    public final HttpClientBuilder setDefaultCookieSpecRegistry(Lookup<CookieSpecFactory> cookieSpecRegistry)

Assigns default `CookieSpec` registry which will be used for request execution if not explicitly set in the client execution context.

See Also:
  `CookieSpecSupport`

#### setContentDecoderRegistry

    public final HttpClientBuilder setContentDecoderRegistry(LinkedHashMap<String,InputStreamFactory> contentDecoderMap)

Assigns a map of `InputStreamFactory`s to be used for automatic content decompression.

#### setDefaultRequestConfig

    public final HttpClientBuilder setDefaultRequestConfig(RequestConfig config)

Assigns default `RequestConfig` instance which will be used for request execution if not explicitly set in the client execution context.

#### useSystemProperties

    public final HttpClientBuilder useSystemProperties()

Use system properties when creating and configuring default implementations.

#### evictExpiredConnections

    public final HttpClientBuilder evictExpiredConnections()

Makes this instance of HttpClient proactively evict expired connections from the connection pool using a background thread.

One MUST explicitly close HttpClient with `Closeable.close()` in order to stop and release the background thread.

Please note this method has no effect if the instance of HttpClient is configured to use a shared connection manager.

Since:
  4.4
See Also:
  `setConnectionManagerShared(boolean)`, `ConnPoolControl.closeExpired()`

#### evictIdleConnections

    public final HttpClientBuilder evictIdleConnections(TimeValue maxIdleTime)

Makes this instance of HttpClient proactively evict idle connections from the connection pool using a background thread.

One MUST explicitly close HttpClient with `Closeable.close()` in order to stop and release the background thread.

Please note this method has no effect if the instance of HttpClient is configured to use a shared connection manager.

Parameters:
  `maxIdleTime` - maximum time persistent connections can stay idle while kept alive in the connection pool. Connections whose inactivity period exceeds this value will get closed and evicted from the pool.
Since:
  4.4
See Also:
  `setConnectionManagerShared(boolean)`, `ConnPoolControl.closeIdle(TimeValue)`

#### disableDefaultUserAgent

    public final HttpClientBuilder disableDefaultUserAgent()

Disables the default user agent set by this builder if none has been provided by the user.

Since:
  4.5.7

#### setProxySelector

    public final HttpClientBuilder setProxySelector(ProxySelector proxySelector)

Sets the `ProxySelector` that will be used to select the proxies to be used for establishing HTTP connections. If a non-null proxy selector is set, it will take precedence over the proxy settings configured in the client.

Parameters:
  `proxySelector` - the `ProxySelector` to be used, or null to use the default system proxy selector.
Returns:
  this `HttpClientBuilder` instance, to allow for method chaining.

#### customizeExecChain

    @Internal
    protected void customizeExecChain(NamedElementChain<ExecChainHandler> execChainDefinition)

Request exec chain customization and extension.

For internal use.

#### addCloseable

    @Internal
    protected void addCloseable(Closeable closeable)

Adds to the list of `Closeable` resources to be managed by the client.

For internal use.

#### build

    public CloseableHttpClient build()